using System;
using System.Runtime.InteropServices;

namespace MGEgui {
    /// <summary>
    /// This class contains all imported unmanaged functions.
    /// </summary>
    /// <remarks>
    /// It's easier to keep them in one place if I'm going to keep changing names around
    /// </remarks>
    internal class NativeMethods {
        [DllImport("MGE3/MGEfuncs.dll", CallingConvention=CallingConvention.StdCall,
            CharSet=CharSet.Ansi, EntryPoint="ProcessNif")]
        internal static extern float ProcessNif(
            [MarshalAs(UnmanagedType.LPArray)] byte[] data, int datasize, string outpath, float cutoff, float cutoff2);

        #region Key remapper
        [DllImport("MGE3/MGEfuncs.dll", CallingConvention=CallingConvention.StdCall,
            CharSet=CharSet.Ansi, EntryPoint="MGEKeyRemapper_Init")]
        internal static extern byte RemapperInit(IntPtr window);

        [DllImport("MGE3/MGEfuncs.dll", CallingConvention=CallingConvention.StdCall,
            CharSet=CharSet.Ansi, EntryPoint="MGEKeyRemapper_End")]
        internal static extern void RemapperEnd();

        [DllImport("MGE3/MGEfuncs.dll", CallingConvention=CallingConvention.StdCall,
            CharSet=CharSet.Ansi, EntryPoint="MGEKeyRemapper_Pressed")]
        internal static extern byte RemapperPressed();
        #endregion

    }
}
