#include "LOG.h"
#include "mwse\\MWSEmain.h"
#include "mge\\mgeversion.h"

static bool IsMorrowind=false;

//TODO: Check FUNCHASEQUIPEDPART2 works - uses dodgy breakpoint
//TODO: Get rid of the pipe between mwse/mge

//cell water size is incorrect
//multiple water types
//fix shadows

//Render higher quality distant land by only using part of the index buffer in each drawprimitive call
//Stuttering water
//Reflect statics

static const char WelcomeMessage[]=
    "Morrowind Script Extender v0.9.3\r\n"
	VERSION "\r\n"
    "MWSE Copyright (C) 2003-2007 FreshFish copyleft GPL\r\n"
    "\r\nThis program is free software, licensed according to the GNU Public License,\r\n"
    "and comes with ABSOLUTELY NO WARRANTY.  Visit http://www.gnu.org/copyleft/gpl.html for details.\r\n"
    "MWSE contributers: cdcooley, Fliggerty, Tp21, Timeslip and probably others\r\n"
	"MGE contributers: Shon, Scanti"
	"\r\n\r\n";


extern void* CreateD3DWrapper(UINT);
extern void MGEOnProcessStart(HANDLE pipe);
extern void* CreateInputWrapper(void*);
extern void DInputOnProcessStart();
typedef void* (_stdcall *D3DProc)(UINT version);
typedef HRESULT (_stdcall *DInputProc)(HINSTANCE a,DWORD b,REFIID c,void** d,void* e);

//Tempory, until updated versions of old MGE mods have been released
HANDLE MGEpipe2;
HANDLE MWSEpipe2;

HRESULT _stdcall FakeDirectInputCreate(HINSTANCE a,DWORD b,REFIID c,void** d,void* e) {
	void* ret=0;

	HMODULE dinput8dll=NULL;    //Handle to the real dinput dll
    DInputProc func=NULL;       //Handle to the real create dinput8 function

	char Path[MAX_PATH];
	GetSystemDirectoryA(Path,MAX_PATH);
	strcat_s(Path,256,"\\dinput8.dll");
	dinput8dll=::LoadLibraryA(Path);
	func=(DInputProc)GetProcAddress(dinput8dll,"DirectInput8Create");
	HRESULT hr=(func)(a,b,c,&ret,e);
	if(hr!=S_OK) return hr;

	if(!IsMorrowind) *d=ret; else *d=CreateInputWrapper(ret);
	return S_OK;
}

void* _stdcall FakeDirect3DCreate(UINT version) {
	void* ret=0;
	if(IsMorrowind)	ret=CreateD3DWrapper(version);
	if(ret) return ret;

	//not morrowind or hook failed, so load the real d3d8 dll
	HMODULE d3ddll=0;
	D3DProc func=0;
	char Path[MAX_PATH];
	GetSystemDirectoryA(Path,MAX_PATH);
	strcat_s(Path,MAX_PATH,"\\d3d8.dll");
	d3ddll=LoadLibraryA(Path);
	func=(D3DProc)GetProcAddress(d3ddll,"Direct3DCreate8");
	return (func)(version);
}

BOOL _stdcall DllMain(HANDLE hModule, DWORD reason, void* unused)
{
	if(reason!=DLL_PROCESS_ATTACH) return true;
	if(IsMorrowind) return true; //This function has somehow been called twice.

	STARTUPINFO info;
	GetStartupInfo(&info);
	//Strip the directory name if it exists. There's probably a function to do this automatically...
	char buf[MAX_PATH]="\0";
	int count=strlen(info.lpTitle);
	while(info.lpTitle[count]!='\\'&&count!=0) count--;
	strcpy(buf,&info.lpTitle[count+1]);
	_strlwr(buf); //Should already be lowercase, but check anyway
	
	if(strcmp(buf,"morrowind.exe")) return true;
	IsMorrowind=true;

	LOG::open("mwse-mge log.txt");
	LOG::log(WelcomeMessage);
	LOG::log("DLL injected\r\n");

	if(FindWindow(0, GUI_VERSION)) {
		LOG::log("Error: MGEgui is running. Please shut it down before launching morrowind.");
		MessageBox(0, "MGEgui is running. Please shut it down before launching morrowind.", "Error", 0);
		return false;
	}

	HANDLE MGEpipe;
	HANDLE MWSEpipe;

	MWSEpipe = CreateNamedPipeA("\\\\.\\pipe\\MWSEMGEpipe", PIPE_ACCESS_DUPLEX, 
					PIPE_TYPE_BYTE | PIPE_READMODE_BYTE | PIPE_NOWAIT,
					PIPE_UNLIMITED_INSTANCES, 4096, 4096, 20000, NULL);
	MWSEpipe2 = CreateNamedPipeA("\\\\.\\pipe\\MWSEMGEpipe2", PIPE_ACCESS_DUPLEX, 
					PIPE_TYPE_BYTE | PIPE_READMODE_BYTE | PIPE_NOWAIT,
					PIPE_UNLIMITED_INSTANCES, 4096, 4096, 20000, NULL);

	if(MWSEpipe==INVALID_HANDLE_VALUE||MWSEpipe2==INVALID_HANDLE_VALUE) {
		LOG::log("Failed to create mge-mwse pipe");
		return false;
	}

	MGEpipe = CreateFile("\\\\.\\pipe\\MWSEMGEpipe", GENERIC_WRITE|GENERIC_READ,0,NULL,OPEN_EXISTING,0,NULL);
	MGEpipe2 = CreateFile("\\\\.\\pipe\\MWSEMGEpipe2", GENERIC_WRITE|GENERIC_READ,0,NULL,OPEN_EXISTING,0,NULL);

	if(MGEpipe==INVALID_HANDLE_VALUE||MGEpipe2==INVALID_HANDLE_VALUE) {
		LOG::log("Failed to open mge-mwse pipe");
		return false;
	}

	MWSEOnProcessStart(MWSEpipe);
	MGEOnProcessStart(MGEpipe);
	DInputOnProcessStart();

	return true;
}