#define _MMEfunctions
#include "d3d8header.h"
#include <sys/stat.h>

int DebugTesterThing=0;
void TakeScreenshot() {
    if(RealDevice==NULL) return;
    HRESULT hr;
    IDirect3DSurface* surface;
#ifndef RELEASE
	hr=RealDevice->CreateOffscreenPlainSurface(1280,1024,
        D3DFMT_A8R8G8B8,D3DPOOL_SCRATCH,&surface,NULL);
#else
    hr=RealDevice->CreateOffscreenPlainSurface(JointInfo.GraphicsWidth,JointInfo.GraphicsHeight,
        D3DFMT_A8R8G8B8,D3DPOOL_SCRATCH,&surface,NULL);
#endif
    if(hr!=D3D_OK) return;
    hr=RealDevice->GetFrontBufferData(0,surface);
    if(hr==D3D_OK) {
        char FileNameStart[16]="MGE Screenshot ";
        char FileNameEnds[30]=".bmp\0.jpg\0.gif\0.tif\0.dds\0.png";
        char FileNameEnd[5];
        char FileName[25]; FileName[0]='\0';
        char TempFileName[30]; TempFileName[0]='\0';
        char Number[6]="\0    ";
        struct _stat64i32 unused;
        for(long i=1;i<32000;i++) {
            FileName[0]='\0';
            _ltoa_s(i,Number,6,10);
            strcat_s(FileName,25,FileNameStart);
            strcat_s(FileName,25,Number);
            for(int i=0;i<5;i++) FileNameEnd[i]=FileNameEnds[i+Options.SaveFormat*5];
            strcat_s(FileName,FileNameEnd);
            if(_stat64i32(FileName,&unused)==-1) {
                if(Options.SaveFormat==0) {
                    hr=D3DXSaveSurfaceToFile(FileName,D3DXIFF_BMP,surface,NULL,NULL);
                } else if(Options.SaveFormat==4) {
                    hr=D3DXSaveSurfaceToFile(FileName,D3DXIFF_DDS,surface,NULL,NULL);
                } else if(Options.SaveFormat==1) {
                    hr=D3DXSaveSurfaceToFile(FileName,D3DXIFF_JPG,surface,NULL,NULL);
                } else if(Options.SaveFormat==5) {
                    hr=D3DXSaveSurfaceToFile(FileName,D3DXIFF_PNG,surface,NULL,NULL);
                }
                break;
            }
        }
    }
    if(hr==D3D_OK) {
        SETSTATUS("Screen shot saved");
    } else {
        SETSTATUS("Screen shot failed");
    }
    surface->Release();
}

void ToggleFog() {
    if(RealDevice==NULL) return;
    RealDevice->SetRenderState(D3DRS_FOGENABLE,(Options.Fog=!Options.Fog));
    if(Options.Fog) {
        SETSTATUS("Fogging enabled");
    } else {
        SETSTATUS("Fogging disabled");
    }

}
void CycleScaleFilter() {
    if(RealDevice==NULL) return;
    if(++Options.MagMinFilter==6) Options.MagMinFilter=1;
    //RealDevice->SetSamplerState(0,D3DSAMP_MAGFILTER,Options.MagMinFilter);
    RealDevice->SetSamplerState(0,D3DSAMP_MINFILTER,Options.MagMinFilter);
    switch(Options.MagMinFilter) {
        case 1:SETSTATUS("Using point mag and min filters");break;
        case 2:SETSTATUS("Using linear mag and min filters");break;
        case 3:SETSTATUS("Using anisotropic mag and min filters");break;
        case 4:SETSTATUS("Using flat cubic mag and min filters");break;
        case 5:SETSTATUS("Using gaussian cubic mag and min filters");break;
    }
}
void CycleMipFilter() {
    if(RealDevice==NULL) return;
    if(++Options.MipFilter==6) Options.MipFilter=1;
    switch(Options.MipFilter) {
        case 1:SETSTATUS("Using a point mip filter");break;
        case 2:SETSTATUS("Using a linear mip filter");break;
        case 3:SETSTATUS("Using a anisotropic mip filter");break;
        case 4:SETSTATUS("Using a flat cubic mip filter");break;
        case 5:SETSTATUS("Using a gaussian cubic mip filter");break;
    }
}

void CycleFogMode() {
    if(RealDevice==NULL) return;
    if(++Options.FogMode==3) Options.FogMode=0;
    switch(Options.FogMode) {
        case 0:
            Options.FogPixelMode=3;
            Options.FogVertexMode=0;
            Options.RangedFog=0;
            RealDevice->SetRenderState(D3DRS_FOGVERTEXMODE,0);
            RealDevice->SetRenderState(D3DRS_FOGTABLEMODE,3);
            RealDevice->SetRenderState(D3DRS_RANGEFOGENABLE,0);
            SETSTATUS("Using depth based per pixel fog");
            break;
        case 1:
            Options.FogPixelMode=0;
            Options.FogVertexMode=3;
            Options.RangedFog=0;
            RealDevice->SetRenderState(D3DRS_FOGVERTEXMODE,3);
            RealDevice->SetRenderState(D3DRS_FOGTABLEMODE,0);
            RealDevice->SetRenderState(D3DRS_RANGEFOGENABLE,0);
            SETSTATUS("Using depth based per vertex fog");
            break;
        case 2:
            Options.FogPixelMode=0;
            Options.FogVertexMode=3;
            Options.RangedFog=1;
            RealDevice->SetRenderState(D3DRS_FOGVERTEXMODE,3);
            RealDevice->SetRenderState(D3DRS_FOGTABLEMODE,0);
            RealDevice->SetRenderState(D3DRS_RANGEFOGENABLE,1);
            SETSTATUS("Using range based per vertex fog");
            break;
    }
}
void ToggleAntialias() {
    if(RealDevice==NULL) return;
    RealDevice->SetRenderState(D3DRS_MULTISAMPLEANTIALIAS,(Options.AA=!Options.AA));
    if(Options.AA) {
        SETSTATUS("Fullscreen antialiasing enabled");
    } else {
        SETSTATUS("Fullscreen antialiasing disabled");
    }
}
void CycleAnisoLevel() {
    if(RealDevice==NULL) return;
    if((Options.AnsiLevel*=2)==32) Options.AnsiLevel=1;
    RealDevice->SetSamplerState(0,D3DSAMP_MAXANISOTROPY,Options.AnsiLevel);
    switch(Options.AnsiLevel) {
        case 1:SETSTATUS("Anisotropic filtering off");break;
        case 2:SETSTATUS("Using 2x anisotropic filtering");break;
        case 4:SETSTATUS("Using 4x anisotropic filtering");break;
        case 8:SETSTATUS("Using 8x anisotropic filtering");break;
        case 16:SETSTATUS("Using 16x anisotropic filtering");break;
    }
}
void ToggleZoom() {
    if(RealDevice==NULL) return;
    Zoom=!Zoom;
    if(Zoom) {
        SETSTATUS("Zoom enabled");
    } else {
        SETSTATUS("Zoom disabled");
    }
}
void IncreaseZoom() {
    SatUp(&FOV,MAXZOOM,ZOOMSTEP);
}
void DecreaseZoom() {
    SatDown(&FOV,MINZOOM,ZOOMSTEP);
}
void RotateScreen() {
    if(RealDevice==NULL) return;
    Rotation+=PI/2.0f;
    UpdateRotation();
}
void ToggleStatusText() {
    Options.DisplayMessages=!Options.DisplayMessages;
}
void ToggleFpsCounter() {
    Options.DisplayFPS=!Options.DisplayFPS;
}
void ShowLastMessage() {
    StatusStringTime=GetTickCount()+2000;
}
void ToggleHardwareShader() {
    if(RealDevice==NULL) return;
    if(ShaderStruct.DefaultEffects==0) {
        SETSTATUS("Cannot enable hardware shaders because there are none active");
        return;
    }
    Options.HWShader=!Options.HWShader;
    if(Options.HWShader) {
        SETSTATUS("Hardware shader on");
    } else {
        SETSTATUS("Hardware shader off");
    }
}
void IncreaseFog() {
    if(RealDevice==NULL) return;
    SatDown(&FogRange,MINFOG,FOGSTEP);
    UpdateFogRange();
}
void DecreaseFog() {
    if(RealDevice==NULL) return;
    SatUp(&FogRange,MAXFOG,FOGSTEP);
    UpdateFogRange();
}
void ToggleAAFix() {
    if(RealDevice==NULL) return;
    Options.UseAAFix=!Options.UseAAFix;
    if(Options.UseAAFix) {
        SETSTATUS("AA colour fix on");
    } else {
        SETSTATUS("AA colour fix off");
    }
}
void IncreaseView() {
    if(!LoadedMemMap) LoadMemMap();
    float f = read_float(MemMap[eView0]);
    SatUp(&f,MAXVIEWDISTANCE,50);
    write_float(MemMap[eView0],f);
    write_float(MemMap[12],f);
    write_float(MemMap[15],f);
    write_float(MemMap[20],f);
    write_float(MemMap[23],f);
    if(Options.BindAIToView) {
        float f2=f/STDMAXVIEWDISTANCE;
        write_float(MemMap[eAI],f2);
    }
    if(Options.DisplayMessages&&RealDevice!=NULL) {
        char str[11];
        char str2[27]; str2[0]='\0';
        strcat(str2,"View distance: ");
        _gcvt_s(str,10,f,8);
        strcat_s(str2,26,str);
        SETSTATUS(str2);
    }
}
void DecreaseView() {
    if(!LoadedMemMap) LoadMemMap();
    float f = read_float(MemMap[eView0]);
    SatDown(&f,MINVIEWDISTANCE,50);
    write_float(MemMap[eView0],f);
    write_float(MemMap[12],f);
    write_float(MemMap[15],f);
    write_float(MemMap[20],f);
    write_float(MemMap[23],f);
    if(Options.BindAIToView) {
        float f2=f/STDMAXVIEWDISTANCE;
        write_float(MemMap[eAI],f2);
    }
    if(Options.DisplayMessages&&RealDevice!=NULL) {
        char str[11];
        char str2[27]; str2[0]='\0';
        strcat(str2,"View distance: ");
        _gcvt_s(str,10,f,8);
        strcat_s(str2,26,str);
        SETSTATUS(str2);
    }
}
void IncreaseAI() {
    if(!LoadedMemMap) LoadMemMap();
    float f = read_float(MemMap[9]);
    SatUp(&f,1,0.015625f);
    write_float(MemMap[eAI],f);
    if(Options.DisplayMessages&&RealDevice!=NULL) {
        char str[15];
        char str2[31]; str2[0]='\0';
        strcat(str2,"AI distance: ");
        _gcvt(f,8,str);
        strcat_s(str2,30,str);
        SETSTATUS(str2);
    }
}
void DecreaseAI() {
    if(!LoadedMemMap) LoadMemMap();
    float f = read_float(MemMap[9]);
    SatDown(&f,0,0.015625f);
    write_float(MemMap[eAI],f);
    if(Options.DisplayMessages&&RealDevice!=NULL) {
        char str[15];
        char str2[31]; str2[0]='\0';
        strcat(str2,"AI distance: ");
        _gcvt(f,8,str);
        strcat_s(str2,30,str);
        SETSTATUS(str2);
    }
}
void IncreaseLOD() {
    if(RealDevice==NULL) return;
    if(Options.LodBias>-12) Options.LodBias--;
    float f=Options.LodBias;
    RealDevice->SetSamplerState(0,D3DSAMP_MIPMAPLODBIAS,*(DWORD*)&f);
    if(Options.DisplayMessages) {
        char str[5];
        char str2[21]; str2[0]='\0';
        strcat(str2,"LOD bias: ");
        _itoa(Options.LodBias,str,10);
        strcat_s(str2,20,str);
        SETSTATUS(str2);
    }
}
void DecreaseLOD() {
    if(RealDevice==NULL) return;
    if(Options.LodBias<12) Options.LodBias++;
    float f=Options.LodBias;
    RealDevice->SetSamplerState(0,D3DSAMP_MIPMAPLODBIAS,*(DWORD*)&f);
    if(Options.DisplayMessages) {
        char str[5];
        char str2[21]; str2[0]='\0';
        strcat(str2,"LOD bias: ");
        _itoa(Options.LodBias,str,10);
        strcat_s(str2,20,str);
        SETSTATUS(str2);
    }
}
void ToggleCrosshair() {
    if(!LoadedMemMap) LoadMemMap();
    MemMap[eCrosshair2]=GetCrosshair2();
    BYTE b=read_byte(MemMap[eCrosshair2]);
    BYTE b2=read_byte(MemMap[eCrosshair1]);
    write_byte(MemMap[eCrosshair2],b ^ 0x01);
    write_byte(MemMap[eCrosshair1],b2 ^ 0x01);
}
void NextTrack() {
    if(!LoadedMemMap) LoadMemMap();
    MemMap[eMusicVol]=GetMusicVol();
    float f=read_float(MemMap[eMusicVol]);
    //SatUp(&f,1,0.1);
    //write_float(MemMap[eMusicVol], f);
    //write_float(MemMap[eMusicVol] - 0x08, f);
    mmVolumeProc mvp=(mmVolumeProc)MemMap[eMusicVolFunc];
    __asm {
        mov ecx, MemMap[eMusicVol];
        sub ecx, 0x294;
    }
    mvp(f);
}
void DisableMusic() {
    if(!LoadedMemMap) LoadMemMap();
    MemMap[eMusicVol]=GetMusicVol();
    //float f=read_float(MemMap[eMusicVol]);
    //SatUp(&f,1,0.1);
    write_float(MemMap[eMusicVol], 0.05f);
    write_float(MemMap[eMusicVol] - 0x08, 0.05f);
    mmVolumeProc mvp=(mmVolumeProc)MemMap[eMusicVolFunc];
    __asm {
        mov ecx, MemMap[eMusicVol];
        sub ecx, 0x294;
    }
    mvp(0.05f);
}
void HaggleMore1() {
    if(!LoadedMemMap) LoadMemMap();
    if(GetMorrowVersion()!=1820) {
        SETSTATUS("This macro requires bloodmoon");
        return;
    }
    mmHaggleProc proc=(mmHaggleProc)MemMap[eHaggleMore];
    proc();
}
void HaggleMore100() {
    if(!LoadedMemMap) LoadMemMap();
    if(GetMorrowVersion()!=1820) {
        SETSTATUS("This macro requires bloodmoon");
        return;
    }
    mmHaggleProc proc=(mmHaggleProc)MemMap[eHaggleMore];
    long d=(long)read_dword(0x7D287C);
    if(d<=0) d-=99; else d+=99;
    write_dword(0x7D287C,d);
    proc();
}
void HaggleMore10000() {
    if(!LoadedMemMap) LoadMemMap();
    if(GetMorrowVersion()!=1820) {
        SETSTATUS("This macro requires bloodmoon");
        return;
    }
    mmHaggleProc proc=(mmHaggleProc)MemMap[eHaggleMore];
    long d=(long)read_dword(0x7D287C);
    if(d<=0) d-=9999; else d+=9999;
    write_dword(0x7D287C,d);
    proc();
}
void HaggleLess1() {
    if(!LoadedMemMap) LoadMemMap();
    if(GetMorrowVersion()!=1820) {
        SETSTATUS("This macro requires bloodmoon");
        return;
    }
    mmHaggleProc proc=(mmHaggleProc)MemMap[eHaggleLess];
    proc();
}
void HaggleLess100() {
    if(!LoadedMemMap) LoadMemMap();
    if(GetMorrowVersion()!=1820) {
        SETSTATUS("This macro requires bloodmoon");
        return;
    }
    mmHaggleProc proc=(mmHaggleProc)MemMap[eHaggleLess];
    long d=(long)read_dword(0x7D287C);
    if(d<=0) d+=99; else d-=99;
    write_dword(0x7D287C,d);
    proc();
}
void HaggleLess10000() {
    if(!LoadedMemMap) LoadMemMap();
    if(GetMorrowVersion()!=1820) {
        SETSTATUS("This macro requires bloodmoon");
        return;
    }
    mmHaggleProc proc=(mmHaggleProc)MemMap[eHaggleLess];
    long d=(long)read_dword(0x7D287C);
    if(d<=0) d+=9999; else d-=9999;
    write_dword(0x7D287C,d);
    proc();
}
void ToggleDistantLand() {
	if(!Options.UseDistantLand) {
		SETSTATUS("Distant land is not enabled in the GUI");
		return;
	}
	UsingDistantLand=!UsingDistantLand;
	if(!UsingDistantLand) DL_Deactivate();
	else DL_Activate();
}
