#define _D3D8
#include "d3d8header.h"

void MGEOnProcessStart(HANDLE pipe) {
		//zero all the structs
		ZeroStruct(JointInfo);
		ZeroStruct(Options);
		ZeroStruct(fpsString);
		ZeroStruct(ShaderStruct);
		ZeroStruct(RcpRes);
		ZeroStruct(SinVar);
		ZeroStruct(LinVar);
		ZeroStruct(EyeVec);
		ZeroStruct(EyePos);
		ZeroStruct(SunVec);
		ZeroStruct(SunCol);
		ZeroStruct(AmbCol);
		EyeVec.w=1;
		//Set some values for some structs
		fpsRect.bottom=35;
		fpsRect.right=600;
		fpsRect.left=5;
		fpsRect.top=20;
		StatusRect.bottom=20;
		StatusRect.right=600;
		StatusRect.left=5;
		StatusRect.top=5;
		fpsColor.a=255;
		fpsColor.r=255;
		fpsColor.b=255;
		fpsColor.g=255;
		fps=0;
		//Setup any global variables
		UsingDistantLand=false;
		RealDevice=NULL;
		BackBuffer=NULL;
		DepthBuffer=NULL;
		StateBlock=0;
		Font=NULL;
		StatusStringTime=0;
		//Scenecount
		SceneCount=0;
		HUDScene=-1;
		AlphaScene=-1;
		SolarScene=-1;
		Indoors=false;
		UpdateScene=false;
		LastSceneCount=0;
		Indoors=false;
		PixelShading=false;
		//fps variables (Could make an fps structure I suppose)
		fpsLastTime=0;
		fpsFrames=0;
		fpsAdjusting=false;
		//These are variables used for graphics features which cant be set by MGEgui
		Zoom=false;
		FOV=4.0f;
		FogRange=1.0f;
		FogStart=0;
		FogEnd=0;
		Rotation=(PI*Options.Rotation)/2;
		D3DXMatrixRotationZ(&RotateMatrix,Rotation);
		MaxViewRange=STDMAXVIEWDISTANCE;
		MinViewRange=STDMINVIEWDISTANCE;
		//MWSE stuff
		//Lighting
		ZeroStruct(LightIDs);
		ActiveLights=0;
		//STANDARD stuff
		ZeroStruct(Objects);
		UsedMWSEobjects=0;
		ZeroStruct(HUDbits);
		UsedHUDbits=0;
		HUDsprite=NULL;
		ZeroStruct(LoadedTextures);
		LastTimer=0;
		UsedMWSEShaders=0;
		HookNextTexture=false;
		NextTexIsWater=false;
		NextHookIndex=0;
		ZeroStruct(HookedTextures);
		HookedShaderActive=0;
		ActiveHookedShader=0;
		for(int i=0;i<8;i++) SetHookedTextures[i]=255;
		//Camera shake
		CameraShake=false;
		CameraShakeAmp=0;
		CameraShakeChange=false;
		CameraShakeChangeRate=0;
		D3DXMatrixTranslation(&CameraShakeMatrix,0,0,0);
		//fps independent stuff
		FOVZooming=false;
		FOVZoomRate=0;
		FogZooming=false;
		FogZoomRate=0;
		RotSpinning=false;
		RotSpinRate=0;
		//Exterior lighting control
		SunManual=false;
		SunManColour=false;
		SunManDir=false;
		AmbientManual=false;
		FogManual=false;
		ClsManual=false;
		SkyManual=false;
		HUDManual=false;
		ZeroStruct(SunDirection);
		SunColour=D3DXCOLOR(0,0,0,0);
		AmbientColour=0;
		FogColour=0;
		ClsColour=0;
		SkyColour=0;
		HUDColour=0xFFFFFFFF;
		SunTexture=NULL;
		//Texture spamming
		TexRenderTarget=NULL;
		TexCopyTo=NULL;
		SufRenderTarget=NULL;
		SufCopyTo=NULL;
		ZeroStruct(TexDrawOrigin);
		ZeroStruct(TexDrawScale);
		//video stuff
		LoadedVideoCount=0;

		//Morrow mem map
		ZeroStruct(MemMap);
		LoadedMemMap=false;

		//Now init some stuff
		//MWSE timer
		TimerFrequency=0;
		if(!QueryPerformanceFrequency((LARGE_INTEGER*)&TimerFrequency)) {
			TimerFrequency=0;
			DEBUGSTRING("Your computer has no high resolution performance counter available."
				"Some MGE features or plugins will not function correctly.");
		}
		MWSEpipe=pipe;
	}
void UpdateFogRange() {
	if(UsingDistantLand) {
		RealDevice->SetRenderState(D3DRS_FOGSTART,F2DW((float)Options.DL_Distance*8192.0f*FogRange));
		RealDevice->SetRenderState(D3DRS_FOGEND,F2DW((float)Options.DL_Fog*8192.0f*FogRange));
	} else {
		RealDevice->SetRenderState(D3DRS_FOGSTART,F2DW(FogStart*FogRange));
		RealDevice->SetRenderState(D3DRS_FOGEND,F2DW(FogEnd*FogRange));
	}
}
void UpdateRotation() {
    while(Rotation<0) Rotation+=PI*2.0f;
    if(Rotation>PI*2.0f) Rotation=fmod(Rotation,PI*2.0f);
    D3DXMatrixRotationZ(&RotateMatrix,Rotation);
}
void LoadShaderTextures(ID3DXEffect* effect) {
    effect->SetTexture("thisframe",ShaderStruct.thisframe);
    effect->SetTexture("lastframe",ShaderStruct.lastframe);
    effect->SetTexture("lastpass",ShaderStruct.lastpass);
    effect->SetTexture("lastshader",ShaderStruct.lastshader);
    effect->SetVector("rcpres",&RcpRes);
	HRESULT hr;

	DWORD count=1;
	IDirect3DTexture* tex;
	char* TexLastPart;
	char TexFirstPart[22]="Data Files\\Textures\\";
	char TexPath[65];
	char FirstPart[9]="texname";
	char FirstPart2[5]="tex";
	char LastPart[17];
	char Finished[25];
	while(true) {
		_itoa_s(count++,LastPart,16,10);
		Finished[0]='\0';
		strcat_s(Finished,24,FirstPart);
		strcat_s(Finished,24,LastPart);
		hr=effect->GetString(Finished,(LPCSTR*)&TexLastPart);
		if(hr==D3D_OK) {
			TexPath[0]='\0';
			strcat_s(TexPath,64,TexFirstPart);
			strcat_s(TexPath,64,TexLastPart);
			hr=D3DXCreateTextureFromFileA(RealDevice,TexPath,&tex);
			if(hr==D3D_OK) {
				Finished[0]='\0';
				strcat_s(Finished,24,FirstPart2);
				strcat_s(Finished,24,LastPart);
				effect->SetTexture(Finished,tex);
			}
		} else break;
	}
}
void SetShaderVars(ID3DXEffect* effect, DWORD time) {
	if(Options.SetShaderVars) {
		effect->SetVector("sinvar",&SinVar);
		effect->SetVector("linvar",&LinVar);
		effect->SetVector("eyevec",&EyeVec);
		effect->SetVector("eyepos",&EyePos);
		effect->SetVector("sunvec",&SunVec);
		effect->SetVector("suncol",&SunCol);
		effect->SetVector("sunamb",&SunAmb);
		effect->SetInt("tickcount",time);
	}
	if(Options.UseHDR) {
		effect->SetVector("HDR",&HDR);
	}
}
void UpdateLighting(int index) {
    D3DLIGHT8 TempLight;
    BYTE upto=0;
    for(DWORD i=0;i<ActiveLights;i++) {
        RealDevice->GetLight(LightIDs[i],&TempLight);
        if(TempLight.Type==D3DLIGHT_DIRECTIONAL) {
            Objects[index].lights[upto++]=LightIDs[i];
        } else {
            D3DXVECTOR3 vec;
            float f;
            f=abs(D3DXVec3Length(D3DXVec3Subtract(&vec,&Objects[index].pos,(D3DXVECTOR3*)&TempLight.Position)));
            if(f<TempLight.Range) Objects[index].lights[upto++]=LightIDs[i];
        }
        if(upto==8) break;
    }
    Objects[index].NumLights=upto;
}
void UpdateScreenShake() {
    if(CameraShakeAmp<0) return;
    float f=GetTickCount()/1000.0f;
    f=sin(f);
    D3DXMatrixTranslation(&CameraShakeMatrix,f*CameraShakeAmp,0,0);
}
void UpdateSceneNums() {
    if(!LoadedMemMap) LoadMemMap();
    Indoors=!IsExterior();
    HUDScene=SceneCount-1;
    if(Indoors) { SolarScene=-1; } else { SolarScene=SceneCount-2; }
    AlphaScene=SceneCount-2;
    if(!Indoors) {
        AlphaScene--;
        if(PixelShading) AlphaScene--;
    }
}

